
#include <stdint.h>
#include <math.h>


// Custom characters
#define CARACT_GRADUATION   5    // Radio dial scale

// commands
#define LCD_SET_CG_RAM_ADDR 0x40



void lcd_cree_1_char(uint8_t location, uint8_t charmap[])
{
		uint8_t i;
		location &= 0x7; // il y a  8 locations 0-7
		lcd_command(LCD_SET_CG_RAM_ADDR | (location << 3));
		for (i=0; i<8; i++)		{	lcd_putc(charmap[i]);}
 } 


void lcd_cree_5_caract_echelle() 
{
	uint8_t i,j;
	uint8_t tabl_caract_curseur[7];  // 0..4 pour graduations et curseur superposés, 6 pour graduation seule
	  
// graduations de l'échelle horizontale
  uint8_t tabl_caract_graduation[8] =
  {
    0b00000,
    0b00000,
    0b00000,
    0b00000,
    0b00000,
    0b00100,
    0b10101,
    0b10101
  };

// Crée les charactères perso représentant toutes les 5 positions possibles (0..4) du curseur superposés à la graduation
  for(j = 0; j < 5; j++)  // j = 0..4
  {
    for(i = 0; i < 8; i++)   { tabl_caract_curseur[i] = tabl_caract_graduation[i]  | (0b10000 >> j); } 
    lcd_cree_1_char(j, tabl_caract_curseur);
  }

  lcd_cree_1_char(CARACT_GRADUATION, tabl_caract_graduation); // cree 1 caractère  supplémentaire représentant la graduation seule
}



void affiche_curseur(int8_t position)
// affiche le curseur au bon endroit sur l'échelle graduée
{
	position += 40;
	position -=3; // pour une simple raison d'esthétique !
  int pH = position / 5;    // character index (ph = 0..15)
  int pL = position % 5;    // pixel index (colonnne dans le charact) (pL = 0..4)
  
  if(pH > 0)
  {
    lcd_gotoxy(pH  - 1, 1);
    lcd_putc(5); // efface le caract à gauche
  } else { lcd_gotoxy(pH, 1); }
  
  lcd_putc(pL);
  
  if(pH < 15) { lcd_putc(5); } // efface le caract à droite
    
}
