/**
	AD9850-628v1.h

	Firmware pour piloter un circuit DDS : AD9850.
	par Silicium628.

	Ce fichier source "AD9850.h" est libre, vous pouvez le redistribuer et/ou le modifier selon
	les termes de la Licence Publique Générale GNU.
**/



#ifndef AD9850_628v1_h
#define AD9850_628v1_h


#pragma once

#define port_AD980	PORTF

#define	pin_WCL				0b00001000
#define	pin_DATA			0b00000100
#define	pin_FQU				0b00000010
#define	pin_RESET			0b00000001


class AD9850
{

	uint32_t FTW;	// le mot de 32 bits à transmettre au AD9951 en mode série sur le pin SDIO
	uint8_t phase;

public:

	AD9850();
	
	void reset();
	void impulse_FQ_U(); 
	void impulse_clk_W();
	void calcul_FTW(uint32_t frequence);
	void out_FTW();
};

#endif
