/**
	AD9951-628v6.h

	Firmware pour piloter un circuit DDS : AD9951.
	par Silicium628.

	Ce fichier source "AD9951.h" est libre, vous pouvez le redistribuer et/ou le modifier selon
	les termes de la Licence Publique Générale GNU.
**/


#ifndef AD9951_628v6_h
#define AD9951_628v6_h

#pragma once

#define port_AD9951 PORTF

#define	pin_SCLK				0b10000000		// (sortie) sur portF
#define	pin_SDI					0b01000000		// (sortie) sur portF
#define	pin_io_update		0b00100000		// (sortie) sur portF
#define	pin_RST					0b00010000		// (sortie) sur portF

class AD9951
{

	uint64_t FTW;	// le mot de 32 bits à transmettre au AD9951 en mode série sur le pin SDIO -> memorisé sur 64 bits pour les calculs.
	uint64_t OSC_REFCLK;	// la fréquence d'horloge entrée sur le pin 9 (OSC_REFCLK) multipliée par le facteur de la PLL interne
	uint16_t POW;

	uint8_t IB; // INSTRUCTION BYTE

public:

	AD9951();
	void reset();
	void set_ref_clk(uint64_t F_CLK_i,  uint8_t REFCLK_Multiplier_i);
	void DDS_init();
	void out(uint8_t octet_i);
	void impulse_IO_update();
	void impulse_clk();
	uint8_t calcul_FTW(uint32_t frequence, uint32_t *FTW_entier, uint8_t *FTW_decim);
	void out_POW(uint16_t phase_i); // Phase Offset Word
	void out_FTW(); // Frequency Tuning Word 

};

#endif
